import { images } from "../stores";

const worker = new Worker("build/workers/pixel-worker.js");

let i = 0;

let cb = {};

worker.addEventListener("message", ev => {
  if (ev.data.i in cb) {
    cb[ev.data.i](ev.data.result);
  }
})

interface res {
  color: string
  distortedValue: number
  id: string
  value: number
}

export default (img: Image, correctDistortion: boolean): Promise<res[]> => new Promise((res, rej) => {
  i++;
  const _i = i;
  worker.postMessage({ i: _i, pixels: img.overlayData, width: img.width, height: img.height, correctDistortion });
  cb[_i] = res;
});